changeset 91:c35eee0cbd12

service
author Sebastien Jodogne <s.jodogne@gmail.com>
date Fri, 28 Sep 2012 13:41:20 +0200
parents 10184c6eabc0
children aad2fe26587b
files OrthancServer/OrthancInitialization.cpp Resources/Debian/orthanc Resources/Debian/orthanc.json
diffstat 3 files changed, 226 insertions(+), 2 deletions(-) [+]
line wrap: on
line diff
--- a/OrthancServer/OrthancInitialization.cpp	Fri Sep 28 11:51:29 2012 +0200
+++ b/OrthancServer/OrthancInitialization.cpp	Fri Sep 28 13:41:20 2012 +0200
@@ -49,7 +49,8 @@
     }
     else
     {
-#if ORTHANC_STANDALONE == 1 && defined(__linux)
+#if 0 && ORTHANC_STANDALONE == 1 && defined(__linux)
+      // Unused anymore
       // Under Linux, try and open "../../etc/orthanc/Configuration.json"
       try
       {
@@ -70,7 +71,7 @@
       }
 
 #elif ORTHANC_STANDALONE == 1
-      // No default path for the configuration file in Windows
+      // No default path for the standalone configuration
       printf("Using the default Orthanc configuration\n");
       return;
 
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/Resources/Debian/orthanc	Fri Sep 28 13:41:20 2012 +0200
@@ -0,0 +1,152 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides:          orthanc
+# Required-Start:    $local_fs $remote_fs $syslog
+# Required-Stop:     $local_fs $remote_fs $syslog
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Orthanc init script
+# Description:       Orthanc, a lightweight, RESTful DICOM server
+### END INIT INFO
+
+# Author: Sebastien Jodogne <s.jodogne@gmaom.com>
+
+# Do NOT "set -e"
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="Orthanc"
+NAME=orthanc
+DAEMON=/usr/sbin/$NAME
+DAEMON_ARGS=/etc/orthanc/orthanc.json
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/$NAME
+ORTHANC_USER=orthanc:orthanc
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+	# Return
+	#   0 if daemon has been started
+	#   1 if daemon was already running
+	#   2 if daemon could not be started
+	start-stop-daemon --start --quiet --pidfile $PIDFILE --chuid $NODEUSER --exec $DAEMON --test > /dev/null \
+		|| return 1
+	start-stop-daemon --start --quiet --pidfile $PIDFILE --chuid $NODEUSER --exec $DAEMON -- \
+		$DAEMON_ARGS \
+		|| return 2
+	# Add code here, if necessary, that waits for the process to be ready
+	# to handle requests from services started subsequently which depend
+	# on this one.  As a last resort, sleep for some time.
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+	# Return
+	#   0 if daemon has been stopped
+	#   1 if daemon was already stopped
+	#   2 if daemon could not be stopped
+	#   other if a failure occurred
+	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --chuid $NODEUSER --name $NAME
+	RETVAL="$?"
+	[ "$RETVAL" = 2 ] && return 2
+	# Wait for children to finish too if this is a daemon that forks
+	# and if the daemon is only ever run from this initscript.
+	# If the above conditions are not satisfied then add some other code
+	# that waits for the process to drop all resources that could be
+	# needed by services started subsequently.  A last resort is to
+	# sleep for some time.
+	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --chuid $NODEUSER --exec $DAEMON
+	[ "$?" = 2 ] && return 2
+	# Many daemons don't delete their pidfiles when they exit.
+	rm -f $PIDFILE
+	return "$RETVAL"
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+	#
+	# If the daemon can reload its configuration without
+	# restarting (for example, when it is sent a SIGHUP),
+	# then implement that here.
+	#
+	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --chuid $NODEUSER --name $NAME
+	return 0
+}
+
+case "$1" in
+  start)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+	do_start
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  stop)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+	do_stop
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  status)
+       status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
+       ;;
+  #reload|force-reload)
+	#
+	# If do_reload() is not implemented then leave this commented out
+	# and leave 'force-reload' as an alias for 'restart'.
+	#
+	#log_daemon_msg "Reloading $DESC" "$NAME"
+	#do_reload
+	#log_end_msg $?
+	#;;
+  restart|force-reload)
+	#
+	# If the "reload" option is implemented then remove the
+	# 'force-reload' alias
+	#
+	log_daemon_msg "Restarting $DESC" "$NAME"
+	do_stop
+	case "$?" in
+	  0|1)
+		do_start
+		case "$?" in
+			0) log_end_msg 0 ;;
+			1) log_end_msg 1 ;; # Old process is still running
+			*) log_end_msg 1 ;; # Failed to start
+		esac
+		;;
+	  *)
+	  	# Failed to stop
+		log_end_msg 1
+		;;
+	esac
+	;;
+  *)
+	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
+	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+	exit 3
+	;;
+esac
+
+:
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/Resources/Debian/orthanc.json	Fri Sep 28 13:41:20 2012 +0200
@@ -0,0 +1,71 @@
+{
+    /**
+     * General configuration of Orthanc
+     **/
+
+    // Path to the directory that holds the database
+    "StorageDirectory" : "/var/lib/orthanc",
+
+
+
+    /**
+     * Configuration of the HTTP server
+     **/
+
+    // HTTP port for the REST services and for the GUI
+    "HttpPort" : 8000,
+
+
+
+    /**
+     * Configuration of the DICOM server
+     **/
+
+    // The DICOM Application Entity Title
+    "DicomAet" : "ORTHANC",
+
+    // Check whether the called AET corresponds during a DICOM request
+    "DicomCheckCalledAet" : false,
+
+    // The DICOM port
+    "DicomPort" : 4242,
+
+
+
+    /**
+     * Security-related options
+     **/
+
+    // Whether remote hosts can connect to the HTTP server
+    "RemoteAccessAllowed" : false,
+
+    // Whether or not SSL is enabled
+    "SslEnabled" : false,
+
+    // Path to the SSL certificate
+    "SslCertificate" : "certificate.pem",
+
+    // Whether or not the password protection is enabled
+    "AuthenticationEnabled" : false,
+
+    // The list of the registered users. Because Orthanc uses HTTP
+    // Basic Authentication, the passwords are stored as plain text.
+    "RegisteredUsers" : {
+        "alice" : "alicePassword"
+    },
+
+
+
+    /**
+     * Network topology
+     **/
+
+    // The list of the known DICOM modalities
+    "DicomModalities" : {
+        // "sample" : [ "SAMPLESCP", "192.168.100.42", 104 ]
+    },
+
+    // The list of the known Orthanc peers (currently unused)
+    "OrthancPeers" : {
+    }
+}